/** 渲染配置 */
interface IRenderConfig {
	/** 是否使用缓存 */
	cache: boolean
	/** 扩展名 */
	extname: string
}

/** 全局渲染配置 */
export const renderConfig: IRenderConfig = {
	cache: true,
	extname: '.html'
}

/**
 * 配置渲染器
 * @param key 配置键
 * @param value 配置值
 */
export function config<K extends keyof IRenderConfig>(key: K, value: IRenderConfig[K]) {
	renderConfig[key] = value;
}
