import fs from "fs";
import path from "path";
import { Module } from "./module";

export function check(value: any, defaultValue: any = null) {
	return `(()=>{ try{ return (${value})??(${defaultValue}) } catch(e){ return (${defaultValue}) } })()`
}

export const __system__ = {
	for: (value: any, callback: (value: any, key: any) => any) => {
		const result: any[] = [];
		if (value === null || value === undefined) return "";
		if (value instanceof Array) {
			for (const [key, item] of value.entries()) {
				result.push(callback(item, key));
			}
		}
		else {
			for (const [key, item] of Object.entries(value)) {
				result.push(callback(item, key));
			}
		}
		return result.join("");
	},
	if: (value: any, key: number, context: Record<number, boolean>, callback: () => any): any => {
		if (value) {
			context[key] = true;
			return callback();
		}
		else {
			context[key] = false;
			return "";
		}
	},
	elseIf: (value: any, key: number, context: Record<number, boolean>, callback: () => any) => {
		if (context[key]) return "";
		if (value) {
			context[key] = true;
			return callback();
		}
		else {
			context[key] = false;
			return "";
		}
	},
	else: (key: number, context: Record<number, boolean>, callback: () => any) => {
		if (context[key]) return "";
		context[key] = true;
		return callback();
	},
	use: (file: string, name: string, data: any, dirname: string) => {
		const filename = path.resolve(dirname, file);
		const template = Module.get(filename).template(name);
		if (!template) return "";
		return template.resolve()(data);
	}
}
